package com.stormtales.notevault.data.entities;

import androidx.room.Entity;
import androidx.room.Ignore;
import androidx.room.PrimaryKey;
import com.stormtales.notevault.data.sync.SyncStatus;

import java.util.Objects;

@Entity
public class NoteSheet {
    @PrimaryKey(autoGenerate = true)
    private int localID;
    private int songID;
    private String localFileName;
    private String serverFileName;
    private String hash;

    private SyncStatus syncStatus;

    @Ignore
    public NoteSheet(String localFileName, String hash) {
        this.localFileName = localFileName;
        this.hash = hash;
        this.syncStatus = SyncStatus.CREATED;
    }

    @Ignore
    public NoteSheet(int songID, String localFileName, String serverFileName, String hash) {
        this.songID = songID;
        this.localFileName = localFileName;
        this.serverFileName = serverFileName;
        this.hash = hash;
        this.syncStatus = SyncStatus.REMOTE_MODIFIED;
    }


    public NoteSheet() {

    }

    public int getLocalID() {
        return localID;
    }

    public void setLocalID(int localID) {
        this.localID = localID;
    }

    public String getLocalFileName() {
        return localFileName;
    }

    public void setLocalFileName(String localFileName) {
        this.localFileName = localFileName;
    }

    public String getHash() {
        return hash;
    }

    public void setHash(String hash) {
        this.hash = hash;
    }

    public String getServerFileName() {
        return serverFileName;
    }

    public void setServerFileName(String serverFileName) {
        this.serverFileName = serverFileName;
    }

    @Override
    public boolean equals(Object o) {
        if (o == null || getClass() != o.getClass()) return false;
        NoteSheet noteSheet = (NoteSheet) o;
        return localID == noteSheet.localID && Objects.equals(localFileName, noteSheet.localFileName) && Objects.equals(hash, noteSheet.hash);
    }

    @Override
    public int hashCode() {
        return Objects.hash(localID, localFileName, hash);
    }

    public int getSongID() {
        return songID;
    }

    public void setSongID(int songID) {
        this.songID = songID;
    }

    public SyncStatus getSyncStatus() {
        return syncStatus;
    }

    public void setSyncStatus(SyncStatus syncStatus) {
        this.syncStatus = syncStatus;
    }
}
