package com.stormtales.notevault.network.sync.models;

import com.stormtales.notevault.data.entities.NoteSheet;
import com.stormtales.notevault.data.entities.Song;

import java.util.List;
import java.util.stream.Collectors;

public class SongModifyRequest {

    private String serverID;
    private String title;
    private String composer;
    private String genre;
    private int year;
    private List<NoteSheetModifyRequest> noteSheets;

    public SongModifyRequest(String serverID, String title, String composer, String genre, int year) {
        this.serverID = serverID;
        this.title = title;
        this.composer = composer;
        this.genre = genre;
        this.year = year;
    }

    public SongModifyRequest(Song song, List<NoteSheet> noteSheets) {
        this.serverID = song.getServerID();
        this.title = song.getTitle();
        this.composer = song.getComposer();
        this.genre = song.getGenre();
        this.year = song.getYear();
        this.noteSheets = noteSheets.stream().map(noteSheet -> new NoteSheetModifyRequest(noteSheet.getServerFileName(), noteSheet.getHash())).collect(Collectors.toList());
    }

    public String getServerID() {
        return serverID;
    }

    public void setServerID(String serverID) {
        this.serverID = serverID;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getComposer() {
        return composer;
    }

    public void setComposer(String composer) {
        this.composer = composer;
    }

    public String getGenre() {
        return genre;
    }

    public void setGenre(String genre) {
        this.genre = genre;
    }

    public int getYear() {
        return year;
    }

    public void setYear(int year) {
        this.year = year;
    }

    public List<NoteSheetModifyRequest> getNoteSheets() {
        return noteSheets;
    }

    public void setNoteSheets(List<NoteSheetModifyRequest> noteSheets) {
        this.noteSheets = noteSheets;
    }
}
